package org.codehaus.mojo.openjpa;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on openjpa-maven-plugin. Call <pre>  mvn openjpa:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Tue Feb 24 13:02:29 CET 2009
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:openjpa-maven-plugin:1.0", 0 );
        append( sb, "", 0 );

        append( sb, "OpenJPA Maven Plugin 1.0", 0 );
        append( sb, "OpenJPA (http://openjpa.apache.org) tasks for enhancing, SQL creation and schema mapping creation", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 4 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "enhance".equals( goal ) )
        {
            append( sb, "openjpa:enhance", 0 );
            append( sb, "Processes Application model classes and enhances them by running Open JPA Enhancer tool.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "addDefaultConstructor (Default: true)", 2 );
                append( sb, "The JPA spec requires that all persistent classes define a no-arg constructor. This flag tells the enhancer whether to add a protected no-arg constructor to any persistent classes that don\'t already have one. Defaults to true.", 3 );
                append( sb, "", 0 );

                append( sb, "classes (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Location where persistence-enabled classes are located.", 3 );
                append( sb, "", 0 );

                append( sb, "enforcePropertyRestrictions (Default: false)", 2 );
                append( sb, "Whether to throw an exception when it appears that a property access entity is not obeying the restrictions placed on property access. Defaults to false", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Comma separated list of excludes to scan searchDir to pass to the jobs. This option may be used to stop OpenJPA tasks from scanning non-JPA classes (which usually leads to warnings such as \'Type xxx has no metadata\')", 3 );
                append( sb, "", 0 );

                append( sb, "includes (Default: **/*.class)", 2 );
                append( sb, "Comma separated list of includes to scan searchDir to pass to the jobs. This may be used to restrict the OpenJPA tasks to e.g. a single package which contains all the entities.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "Default directory containing the generated resources.", 3 );
                append( sb, "", 0 );

                append( sb, "toolProperties", 2 );
                append( sb, "Additional properties passed to the OpenJPA tools.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "openjpa:help", 0 );
            append( sb, "Display help information on openjpa-maven-plugin. Call\n\u00a0\u00a0mvn\u00a0openjpa:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "schema".equals( goal ) )
        {
            append( sb, "openjpa:schema", 0 );
            append( sb, "Executes the schema generation via the OpenJPA MappingTool.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "action", 2 );
                append( sb, "Argument to specify the action to take on each class. The available actions are: buildSchema, validate", 3 );
                append( sb, "", 0 );

                append( sb, "classes (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Location where persistence-enabled classes are located.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Comma separated list of excludes to scan searchDir to pass to the jobs. This option may be used to stop OpenJPA tasks from scanning non-JPA classes (which usually leads to warnings such as \'Type xxx has no metadata\')", 3 );
                append( sb, "", 0 );

                append( sb, "includes (Default: **/*.class)", 2 );
                append( sb, "Comma separated list of includes to scan searchDir to pass to the jobs. This may be used to restrict the OpenJPA tasks to e.g. a single package which contains all the entities.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "Default directory containing the generated resources.", 3 );
                append( sb, "", 0 );

                append( sb, "schemaAction (Default: add)", 2 );
                append( sb, "The action to take on the schema. Actions can be composed in a comma-separated list of one of the following items:\n-\tadd (see MappingTool#ACTION_ADD)\n-\trefresh (see MappingTool#ACTION_REFRESH)\n-\tdrop (see MappingTool#ACTION_DROP)\n-\tbuildSchema (see MappingTool#ACTION_BUILD_SCHEMA)\n-\timport (see MappingTool#ACTION_IMPORT)\n-\texport (see MappingTool#ACTION_EXPORT)\n-\tvalidate (see MappingTool#ACTION_VALIDATE)\n", 3 );
                append( sb, "", 0 );

                append( sb, "schemaFile (Default: ${project.build.directory}/schema.xml)", 2 );
                append( sb, "Use this option to write the planned schema to an XML document rather than modify the database. The document can then be manipulated and committed to the database with the schema tool", 3 );
                append( sb, "", 0 );

                append( sb, "toolProperties", 2 );
                append( sb, "Additional properties passed to the OpenJPA tools.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "sql".equals( goal ) )
        {
            append( sb, "openjpa:sql", 0 );
            append( sb, "Executes the SQL generation via the OpenJPA MappingTool.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "action", 2 );
                append( sb, "Argument to specify the action to take on each class. The available actions are: buildSchema, validate", 3 );
                append( sb, "", 0 );

                append( sb, "classes (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Location where persistence-enabled classes are located.", 3 );
                append( sb, "", 0 );

                append( sb, "excludes", 2 );
                append( sb, "Comma separated list of excludes to scan searchDir to pass to the jobs. This option may be used to stop OpenJPA tasks from scanning non-JPA classes (which usually leads to warnings such as \'Type xxx has no metadata\')", 3 );
                append( sb, "", 0 );

                append( sb, "includes (Default: **/*.class)", 2 );
                append( sb, "Comma separated list of includes to scan searchDir to pass to the jobs. This may be used to restrict the OpenJPA tasks to e.g. a single package which contains all the entities.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.directory})", 2 );
                append( sb, "Default directory containing the generated resources.", 3 );
                append( sb, "", 0 );

                append( sb, "sqlAction (Default: build)", 2 );
                append( sb, "The action to take for generating the SQL. Actions can be composed in a comma-separated list of one of the following items:\n-\tadd (see MappingTool#ACTION_ADD)\n-\trefresh (see MappingTool#ACTION_REFRESH)\n-\tdrop (see MappingTool#ACTION_DROP)\n-\tbuildSchema (see MappingTool#ACTION_BUILD_SCHEMA)\n-\timport (see MappingTool#ACTION_IMPORT)\n-\texport (see MappingTool#ACTION_EXPORT)\n-\tvalidate (see MappingTool#ACTION_VALIDATE)\nTechnically this is the same like the schemaAction, but we have to split it for the plugin to allow different actions for generating the mapping and generating the SQL files.", 3 );
                append( sb, "", 0 );

                append( sb, "sqlFile (Default: ${project.build.directory}/database.sql)", 2 );
                append( sb, "Use this option to write the planned schema modifications to a SQL script rather than modify the database. Combine this with a schemaAction of \'build\' to generate a script that recreates the schema for the current mappings, even if the schema already exists.", 3 );
                append( sb, "", 0 );

                append( sb, "toolProperties", 2 );
                append( sb, "Additional properties passed to the OpenJPA tools.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     */
    private List toLines( String text, int indent )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i] );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     */
    private void toLines( List lines, String line )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
